﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;

namespace WpfDockingAndRibbonTest
{
   public static class Extensions
    {
        public static void GetChildOfType<T>(this DependencyObject depObj, ref List<T> childrenList) where T : DependencyObject
        {
            if (childrenList == null)
                childrenList = new List<T>();

            if (depObj == null) return;

            for (var i = 0; i < VisualTreeHelper.GetChildrenCount(depObj); i++)
            {
                var child = VisualTreeHelper.GetChild(depObj, i);

                if ((child as T) == null)
                {
                    GetChildOfType(child, ref childrenList);
                }
                else
                {
                    childrenList.Add(child as T);
                    GetChildOfType(child, ref childrenList);
                }
            }
        }

        public static T GetChildOfType<T>(this DependencyObject depObj) where T : DependencyObject
        {
            if (depObj == null) return null;

            for (var i = 0; i < VisualTreeHelper.GetChildrenCount(depObj); i++)
            {
                var child = VisualTreeHelper.GetChild(depObj, i);

                var result = (child as T) ?? GetChildOfType<T>(child);
                if (result != null) return result;
            }
            return null;
        }
    }
}
